new;

/*************************************************
Chernozhukov, Lee, and Rosen (2012)
 Monte Carlo DGPs 1-12
 On-line Supplment Figures 1-6
***************************************************/


output file = MonteCarloDGPs_Figures.out reset;

output off;




format /rd /m1 7,3;

tstart = date;


dgp_set = {1,2,3,4,5,6,7,8,9,10,11,12};  
  n_set = {1000};






i_dgp = 1;
do until i_dgp > rows(dgp_set);

i_n = 1;
do until i_n > rows(n_set); 





/**************************
*** Tuning Parameters  ****
**************************/


         nn = n_set[i_n];          @ sample size in simulations @
        dgp = dgp_set[i_dgp];      @ DGP @ 


              

      b_cns = 3;
 
     b_cns1 = 0.5;



/*********************************
*** Lower bound to be covered ****
*********************************/

if dgp     == 1; true_lb = 0;  
elseif dgp == 2; true_lb = pdfn(0);  
elseif dgp == 3; true_lb = 5*pdfn(0);  
elseif dgp == 4; true_lb = 5*pdfn(0); 

elseif dgp == 5; true_lb = -b_cns1*cdfn(0);  
elseif dgp == 6; true_lb = -b_cns1*cdfn(-1);  
elseif dgp == 7; true_lb = -b_cns1*cdfn(0);  
elseif dgp == 8; true_lb = -b_cns1*cdfn(0); 

elseif dgp  == 9; true_lb = pdfn(0);  
elseif dgp == 10; true_lb = 5*pdfn(0);  
elseif dgp == 11; true_lb = pdfn(0);  
elseif dgp == 12; true_lb = 5*pdfn(0); 
endif;
             
@               
" true_lb " true_lb;
@





/**************************
***    Simulation      ****
**************************/

if (dgp <= 4) or (dgp >= 9); 

seed = 45465657;

elseif (dgp >= 5) and (dgp <= 8);
    
 seed = 2345243;

      RR = 10000;
   rnd_R = rndns(101,RR,seed);   @ random numbers that will be used to callibrate critical values @

endif;


               v = 4*rndus(nn,1,seed)-2;  @ U[-2,2] @
               v = sortc(v,1);

if     dgp == 1;   sm0 = 0.1;  
elseif dgp == 2;   sm0 = 0.1;
elseif dgp == 3;   sm0 = 0.1;
elseif dgp == 4;   sm0 = 0.01;

elseif dgp == 5;   sm0 = 0.1;  
elseif dgp == 6;   sm0 = 0.1;
elseif dgp == 7;   sm0 = 0.1;
elseif dgp == 8;   sm0 = 0.1;

elseif dgp == 9;   sm0 = 0.1;  
elseif dgp == 10;   sm0 = 0.1;
elseif dgp == 11;   sm0 = 0.1;
elseif dgp == 12;   sm0 = 0.1;
endif;


if (dgp <= 4) or (dgp >= 9); 

               u = sm0*rndns(nn,1,seed); 
               u = -b_cns*(u .< -b_cns) + u.*(abs(u) .<= b_cns) + b_cns*(u .> b_cns);  

elseif (dgp >= 5) and (dgp <= 8);

               u = sm0*rndns(nn,1,seed); 
               u = abs(v).*u;        @ unequal variance @               
               u = -b_cns1*(u .< -b_cns1) + u.*(abs(u) .<= b_cns1) + b_cns1*(u .> b_cns1);  

endif;
 

if     dgp == 1;   gx0 = zeros(rows(v),1);  
elseif dgp == 2;   gx0 = pdfn(v);
elseif dgp == 3;   gx0 = 5*pdfn(v);
elseif dgp == 4;   gx0 = 5*pdfn(v);

elseif dgp == 5;   fz0 = 0;                       gx0 = -b_cns1*cdfn(0)*ones(rows(v),1);
elseif dgp == 6;   fz0 = v.*(v .<= 1) + (v .> 1); gx0 = -b_cns1*cdfn(-fz0); 
elseif dgp == 7;   fz0 = -2*(v.^2);               gx0 = -b_cns1*cdfn(-fz0); 
elseif dgp == 8;   fz0 = -10*(v.^2);              gx0 = -b_cns1*cdfn(-fz0); 

               
elseif dgp == 9;    gx0 = pdfn(v^10);  
elseif dgp == 10;   gx0 = 5*pdfn(v^10);
elseif dgp == 11;   gx0 = maxc((pdfn((v-1.5)^10)~pdfn((v+1.5)^10))');
elseif dgp == 12;   gx0 = 5*maxc((pdfn((v-1.5)^10)~pdfn((v+1.5)^10))');
endif;

if (dgp <= 4) or (dgp >= 9); 

          y = gx0 + u;

elseif (dgp >= 5) and (dgp <= 8);

          z = (fz0 + rndns(nn,1,seed) .> 0);  
          y = u.*(z.== 1) + (-b_cns1)*(z./= 1);

endif;


@ ***** PLOT A FIGURE ***** @




library pgraph;


_ptek="fig.tkf"; 
_pdate = "";


_plegctl = 1;
_plegstr ="Data\000Bounding Function";
_plctrl = {-5,0};
_pltype = 6|6;
_plwidth = 1|5;

_pcolor = 1|2;
_pstype= 8|9;


xlabel(" v ");
ylabel(" theta(v) ");
title(" Simulated Data and Bounding Function ");




xtics(-2,2,0.5,5);

if (dgp <= 4);                    ytics(-1,2.5,0.5,5);
elseif (dgp >= 5) and (dgp <= 8); ytics(-1,1,0.5,5);
elseif (dgp == 9);                ytics(-0.4,0.8,0.2,2);
elseif (dgp == 10);               ytics(-0.6,2.6,0.4,2);
elseif (dgp == 11);                ytics(-0.4,0.8,0.2,2);
elseif (dgp == 12);               ytics(-0.6,2.6,0.4,2);
endif;

xy(v,y~gx0);

ret = tkf2ps("fig.tkf","fig"$+ftocv(dgp,2,0)$+".ps");






                   


i_n = i_n + 1;
endo;

i_dgp = i_dgp + 1;
endo;



etime = ethsec(tstart,date)/6000;

output on;
" Running time   " etime;
"";
 output off; 
 
 
end;

